; ========================================
; Test T2 v PMD85 - taktovaný na 1s
; ========================================
; Autor: Zdeněk Šesták, 2018
; Web:   maximalne.8u.cz
;
; Určeno pro PMD85- verze 2 a verze 2a
; Testuje dvěma způsoby:
; a) bez stisknutého shift - atakuje čítač neustálým čtením, může zachytit hazard
; b) se stisknutým shiftem - čte stav čítače co sekundu, vyhne se hazardu
                  jmp   start
sys_hex:          jmp   8125h           ; vektor tisku hex čísla
sys_print:        jmp   8500h           ; vektor tisku znaku
start:
; zobrazení textu
                  lxi   h, msg
prtmsg:           mov   a,m
                  inx   h
                  ana   a
                  jz    test1s
                  call  sys_print
                  jmp   prtmsg

; test 1s - zobrazení hodnot časovače při módu 0
test1s:           ; konfigurace časovače T2 do režimu 0
                  mvi   a,90h
                  out   5fh
                  xra   a
                  out   5eh
                  in    5eh
                  inr   a
                  mov   b,a
                  ; registr B = poslední načtená hodnota
.loop:            ; při stisknutém shiftu se testuje každou sekundu
                  lxi   h,0c03ah
                  mov   a,m
                  ani   3fh
                  mov   m,a
                  in    0f5h
                  cma   
                  ani   20h
                  push  psw
                  add   a
                  ora   m
                  mov   m,a
                  pop   psw                  
                  jnz   .w1s
                  ; jinak se čte až do změny - hrozí hazardy
.ft:              in    5eh
                  cmp   b
                  jz    .ft
                  jmp   .print
                  ; následující kód doplňuje smyčka na  2048000 taktů = 1s na PMD85-2/2A
.w1s:             lxi   h, 30055
.wloop:           xthl
                  xthl
                  dcx   h
                  mov   a,h
                  ora   l
                  jnz   .wloop
                  push  h
                  pop   h
                  sta   0ffffh    
                  in    5eh
.print:           ; je aktuální hodnota ta očekávaná?
                  dcr   b
                  cmp   b
                  mov   b,a
                  push  psw
                  push  b
                  ; zobrazí hodnotu + mezeru nebo vykřičník
                  call  sys_hex
                  pop   b
                  pop   psw
                  jz    .ok
                  ; výpis vykřičníku - načtená hodnota je jiná než ta očekávaná
                  mvi   a,'!'
                  jmp   .next
                  ; výpis mezery - načtená hodnota je jiná než ta očekávaná
.ok:              mvi   a,' '
                  jmp   .next
.next:            call  sys_print
                  ; nastaví kurzor do kruhu
                  lxi   h,0c03eh
                  mov   a,m
                  ani   3fh
                  cpi   40
                  jc    .skip
                  mov   a,m
                  ani   0c0h
                  ori   4
                  mov   m,a
                  lda   0c03ah
                  xri   03fh
                  sta   0c03ah
                  jmp   .loop
.skip:            ; prázdný kód - každá smyčka musí trvat stejně dlouho
                  xthl
                  xthl
                  push  h
                  pop   h
                  mov   a,a
                  jmp   .loop                
msg:              DB    01CH, "TEST SEKUNDOVEHO CASOVACE OBVODU 8253 V MODU 0",0dh
                  DB    "================================================",0dh,0dh
                  DB    "SHIFT - stav citace se cte kazdou sekundu",0dh
                  DB    "Bez SHIFTu - stav se cte neustale (test hazardu)",0dh,0dh, 0dh
                  DB    "T2: ",0